/* A file to rendering Nobel Prize information from JSON into HTML
with *nunjucks*. 
*/

const nunjucks = require('nunjucks');
const prizesJSON = require('./prize.json');
const fs = require('fs'); // The file system module

let catDates = [{
        topic: "physics",
        start: 1926,
        end: 1954,
        title: "Physics",
        fname: "physics.html"
    },
    {
        topic: "chemistry",
        start: 1936,
        end: 1964,
        title: "Chemistry",
        fname: "chemistry.html"
    },
    {
        topic: "economics",
        start: 1940,
        end: 1980,
        title: "Economics",
        fname: "economics.html"
    }];


nunjucks.configure({
    autoescape: true
});
nunjucks.configure('views', {
    autoescape: true
});

// Process prizes.json to get only information of interest
let prizeArray = prizesJSON.prizes;
for (let catDate of catDates) {
    let myPrizes = prizeArray.filter(function (x) {
        return (x.category === catDate.topic) && (x.year >= catDate.start) && (x.year <= catDate.end)
    });
    myPrizes.reverse();
    let prizeInfo = {
        catDate: catDate,
        prizes: myPrizes,
        menu: catDates
    }
    // console.log(JSON.stringify(myPrizes));


    let outString = nunjucks.render('prizes.njk', prizeInfo);
    fs.writeFileSync('./output/' + catDate.fname, outString);
    console.log("Wrote file " + catDate.fname);
}
